diff arduino-ide/hardware/teensy/avr/cores/teensy3/kinetis.h arduino-ide/hardware/teensy/avr/cores/teensy3/kinetis.h
--- arduino-ide/hardware/teensy/avr/cores/teensy3/kinetis.h
+++ arduino-ide/hardware/teensy/avr/cores/teensy3/kinetis.h
@@ -4592,10 +4592,14 @@ typedef struct {
 	volatile uint8_t	SLTH;
 	volatile uint8_t	SLTL;
 } KINETIS_I2C_t;
-#define KINETIS_I2C0		(*(KINETIS_I2C_t *)0x40066000)
-#define KINETIS_I2C1		(*(KINETIS_I2C_t *)0x40067000)
-#define KINETIS_I2C2		(*(KINETIS_I2C_t *)0x400E6000)
-#define KINETIS_I2C3		(*(KINETIS_I2C_t *)0x400E7000)
+#define KINETIS_I2C0_ADDR	0x40066000
+#define KINETIS_I2C1_ADDR	0x40067000
+#define KINETIS_I2C2_ADDR	0x400E6000
+#define KINETIS_I2C3_ADDR	0x400E7000
+#define KINETIS_I2C0		(*(KINETIS_I2C_t *)KINETIS_I2C0_ADDR)
+#define KINETIS_I2C1		(*(KINETIS_I2C_t *)KINETIS_I2C1_ADDR)
+#define KINETIS_I2C2		(*(KINETIS_I2C_t *)KINETIS_I2C2_ADDR)
+#define KINETIS_I2C3		(*(KINETIS_I2C_t *)KINETIS_I2C3_ADDR)
 #define I2C0_A1			(KINETIS_I2C0.A1)		// I2C Address Register 1
 #define I2C0_F			(KINETIS_I2C0.F)		// I2C Frequency Divider register
 #define I2C_F_DIV20			((uint8_t)0x00)
diff arduino-ide/hardware/teensy/avr/libraries/Wire/WireKinetis.cpp arduino-ide/hardware/teensy/avr/libraries/Wire/WireKinetis.cpp
--- arduino-ide/hardware/teensy/avr/libraries/Wire/WireKinetis.cpp
+++ arduino-ide/hardware/teensy/avr/libraries/Wire/WireKinetis.cpp
@@ -901,28 +901,23 @@ constexpr TwoWire::I2C_Hardware_t TwoWire::i2c3_hardware = {
 };
 #endif
 
-// Helper to transform a non-constant expression of the form
-// &(*(KINETIS_I2C_t *)0x40066000)
-// into a compile time constant.
-#define MAKE_CONST(x) (__builtin_constant_p(x) ? (x) : (x))
-
 #ifdef WIRE_IMPLEMENT_WIRE
-constexpr uintptr_t i2c0_addr = uintptr_t(MAKE_CONST(&KINETIS_I2C0));
+constexpr uintptr_t i2c0_addr = uintptr_t(KINETIS_I2C0_ADDR);
 TwoWire Wire(i2c0_addr, TwoWire::i2c0_hardware);
 void i2c0_isr(void) { Wire.isr(); }
 #endif
 #ifdef WIRE_IMPLEMENT_WIRE1
-constexpr uintptr_t i2c1_addr = uintptr_t(MAKE_CONST(&KINETIS_I2C1));
+constexpr uintptr_t i2c1_addr = uintptr_t(KINETIS_I2C1_ADDR);
 TwoWire Wire1(i2c1_addr, TwoWire::i2c1_hardware);
 void i2c1_isr(void) { Wire1.isr(); }
 #endif
 #ifdef WIRE_IMPLEMENT_WIRE2
-constexpr uintptr_t i2c2_addr = uintptr_t(MAKE_CONST(&KINETIS_I2C2));
+constexpr uintptr_t i2c2_addr = uintptr_t(KINETIS_I2C2_ADDR);
 TwoWire Wire2(i2c2_addr, TwoWire::i2c2_hardware);
 void i2c2_isr(void) { Wire2.isr(); }
 #endif
 #ifdef WIRE_IMPLEMENT_WIRE3
-constexpr uintptr_t i2c3_addr = uintptr_t(MAKE_CONST(&KINETIS_I2C3));
+constexpr uintptr_t i2c3_addr = uintptr_t(KINETIS_I2C3_ADDR);
 TwoWire Wire3(i2c3_addr, TwoWire::i2c3_hardware);
 void i2c3_isr(void) { Wire3.isr(); }
 #endif
